#include <Arduino_GFX_Library.h>
#include <lvgl.h>
#include "ui.h"

//Função de start do Barramento do Display (Verificar pinos junto com o projeto de Hardware) e parametros do display:
      Arduino_ESP32RGBPanel *rgbpanel = new Arduino_ESP32RGBPanel(
          40 /* DE */, 41 /* VSYNC */, 39 /* HSYNC */, 0 /* PCLK */,
          45 /* R0 */, 48 /* R1 */, 47 /* R2 */, 21 /* R3 */, 14 /* R4 */,
          5 /* G0 */, 6 /* G1 */, 7 /* G2 */, 15 /* G3 */, 16 /* G4 */, 4 /* G5 */,
          8 /* B0 */, 3 /* B1 */, 46 /* B2 */, 9 /* B3 */, 1 /* B4 */,

          0 /* hsync_polarity */, 210 /* hsync_front_porch */, 4 /* hsync_pulse_width */, 43 /* hsync_back_porch */,
          0 /* vsync_polarity */, 22 /* vsync_front_porch */, 4 /* vsync_pulse_width */, 12 /* vsync_back_porch */,
          0 /* pclk_active_neg */, 16000000 /* prefer_speed */);
          
          Arduino_RGB_Display *gfx = new Arduino_RGB_Display(800 /* width */, 480 /* height */, rgbpanel);
          #include "touch.h"

//Variaveis do LVGL
      #define TFT_BL 2
      //#define GFX_BL DF_GFX_BL // default backlight pin, you may replace DF_GFX_BL to actual backlight pin

      static uint32_t screenWidth = 800;
      static uint32_t screenHeight = 480;
      static lv_disp_draw_buf_t draw_buf;
      static lv_color_t *disp_draw_buf;
      static lv_disp_drv_t disp_drv;

//Calibração Touch
      uint16_t touchCalibration_x0 = 300, touchCalibration_x1 = 3600, touchCalibration_y0 = 300, touchCalibration_y1 = 3600;
      uint8_t  touchCalibration_rotate = 1, touchCalibration_invert_x = 2, touchCalibration_invert_y = 0;


void setup(){
          Serial.begin(115200);
          f_SetupDisplay();
          ui_init();
}

void loop(){
      lv_timer_handler();
}
